#define GNUPORT  "GnuPlot.Port"
#define GNUREPLY "GnuPlot.Reply"

#define RESOLUTION 1024

enum GnuPlotCom
{
 RESET, SET_GRAPHICS, SET_TEXT, PAUSE, SETVAR
};

struct GnuPlotCommand
{
 enum GnuPlotCom      gpc_com;
 void                *gpc_arg;
 int                  gpc_ncommands;
 struct PlotCommand  *gpc_commands;
};

enum PlotCom
{
 LINETYP, MOVE, VECTOR, PUT_TEXT, JUSTIFY, TEXT_ANGLE
};

struct PlotCommand
{
 enum PlotCom   pc_com;
 int            pc_arg1, pc_arg2;
 char          *pc_argstr;
};

struct PlotMessage
{
 struct Message        PlotMsg;
 struct GnuPlotCommand PlotCom;
};

struct SetVar 
{
 double xmin, xmax, ymin, ymax, zmin, zmax, rmin, rmax, tmin, tmax, umin, umax, vmin, vmax;
 BOOL   autox, autoy, autoz, autor, autot, autou, autov;
 double basex, basey, basez;
 BOOL   logx, logy, logz;
 BOOL   hidden3d, surface;
 double rotx, rotz, scale, zscale;
 int    contour;
 int    functionstyle, datastyle;
 char  *title, *xlabel, *ylabel, *zlabel;
 int    title_xoff, title_yoff, xlabel_xoff, xlabel_yoff, ylabel_xoff, ylabel_yoff,
        zlabel_xoff, zlabel_yoff;
 char  *replot;
 BOOL   parametric, polar, grid, border, xzeroaxis, yzeroaxis;
 int    mapping;
 struct udvt_entry *user_variables;
 struct udft_entry *user_functions;
};


extern void SendMsg(enum GnuPlotCom, char *);
extern void UpdateVars(void);
